/*
**********************************************************************************************************************
*											        eGon
*						                     the Embedded System
*									       script parser sub-system
*
*						  Copyright(C), 2006-2010, SoftWinners Microelectronic Co., Ltd.
*                                           All Rights Reserved
*
* File    : standby.c
*
* By      : Jerry
*
* Version : V2.00
*
* Date	  :
*
* Descript:
**********************************************************************************************************************
*/
#include "include.h"
#include "standby.h"


static int eGon2_enter_standby(void);
static int eGon2_exit_standby(void);
static int eGon2_standby_detect(void);
static int eGon2_mod_enter_standby(void);
static int eGon2_mod_exit_standby(void);

static int standby_flag = 0;
static int status;

/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
int eGon2_standby_mode(void)
{
	__u32 dcin_exist, battery_exist;
	__s32 key_status;
	status = -1;
	//Ƿа
	__debug("at the start of %s\n",__FUNCTION__);
	key_status = eGon2_power_get_key();
	if(key_status & 0x01)			//£ܵԴǷƳֱӽϵͳ
	{
		//˳еģ
		if(standby_flag)
		{
			eGon2_mod_exit_standby();
		}
		return 3;
	}
	//ⲿԴǷ
	dcin_exist = 100;
	battery_exist = 100;
	eGon2_power_get_dcin_battery_exist(&dcin_exist, &battery_exist);
	if(!dcin_exist)							//ⲿԴƳ
	{
		//˳еģ
		if(standby_flag)
		{
			eGon2_mod_exit_standby();
		}
		return 6;
	}
//	charge_status = eGon2_power_battery_charge_status();		//
//	if((charge_status > 0) && (battery_exist == 1))
//	{
//		//˳еģ
//		if(standby_flag)
//		{
//			eGon2_mod_exit_standby();
//		}
//		return 7;
//	}
	if(key_status & 0x02)			//ⲿԴڣstandby
	{
		//˳еģ
		if(standby_flag)
		{
			eGon2_mod_exit_standby();
		}
		return 2;
	}
	//ԭSP
	eGon2_store_sp();
	//µSPSRAM
	eGon2_set_sp();

	if(!standby_flag)
	{
		eGon2_mod_enter_standby();
	}
	eGon2_enter_standby();
	//ڣclock32k
	do
	{
		//ʼѭǷʼ
		eGon2_halt();
		status = eGon2_standby_detect();
	}
	while(status <= 0);
	//Ҫѣ˳standby
	eGon2_exit_standby();
	//˳ģstandby
	if((status != 8) && (status != 9))
	{
		eGon2_mod_exit_standby();
		standby_flag = 0;
	}
	else
	{
		standby_flag = 1;
	}    
  
	eGon2_restore_sp();

	return status;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
#define   DCDC2_STANDBY_VOL      (1250)
#define   DCDC3_STANDBY_VOL		 (1250)

static int eGon2_enter_standby(void)
{
	volatile int i;
//	__u8  power_int_status[5];
	//standby
	eGon2_config_charge_current(1);
	//VBUS粻
//	eGon2_power_vbus_cur_limit();
//	//powerжpending
//	eGon2_power_int_query(power_int_status);
	//ж
	//__debug("standby int init\n");
	standby_int_init();
	//clock
	standby_clock_store();

    #ifndef CONFIG_AW_FPGA_PLATFORM
	//dram֮ٷdram
	dram_power_save_process();
	//ֹdrampllʹ
	standby_clock_drampll_ouput(0);
    #endif
	//л24M
	standby_clock_to_source(24000000);
    //__debug("after standby_clock_to_source\n");
	//رpll
	standby_clock_plldisable();
   // __debug("after standby_clock_plldisable\n");
    
	//͵Դѹ
	eGon2_power_set_dcdc2(DCDC2_STANDBY_VOL);
    //__debug("after standby_clock_plldisable\n");
	//eGon2_power_set_dcdc3(DCDC3_STANDBY_VOL);
	//ʹܵԴжϣȴ
	eGon2_power_int_enable();
	//лƵȫΪ0
	standby_clock_divsetto0();
    //__debug("after standby_clock_divsetto0 fail\n");
	//лapb132k
	standby_clock_apb1_to_source(32000);
	//лʱӣرʱ
	for(i=0;i<2000;i++);
	standby_clock_to_source(32000);
	//ر24M
	standby_clock_24m_op(0);
	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static int eGon2_exit_standby(void)
{
	int i;

	//رյԴж
	eGon2_power_int_disable();
	//õѹ
	eGon2_power_set_dcdc2(-1);
//	eGon2_power_set_dcdc3(-1);
	//ԭpllԭ򿪵򿪣ԭرյĲ
	
	standby_clock_restore();
	for(i=0;i<80000;i++);//0x100000
	//лʱӵPLL1
	standby_clock_to_source(0);
    #ifndef CONFIG_AW_FPGA_PLATFORM
	//dramʹ
	standby_clock_drampll_ouput(1);
	//dram
	standby_tmr_enable_watchdog();
	dram_power_up_process();
	standby_tmr_disable_watchdog();
    #endif
	//ԭж״̬
	standby_int_exit();
	//ԭ
	eGon2_config_charge_current(0);
	//ԭеģ
	//eGon2_timer_delay(50);

	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static int eGon2_standby_detect(void)
{
	int   i;
	__u32 dcin_exist, battery_exist;
	__u8  power_int_status[5];

	//24M
	standby_clock_24m_op(1);
	//лapb124M
	standby_clock_apb1_to_source(24000000);
	//Ƶʵ24M
	standby_clock_to_source(24000000);
	standby_clock_divsetback();
	for(i=0;i<2000;i++);
	//жϴ
	eGon2_power_int_query(power_int_status);
	//жϿpending
//	standby_int_query();
//	if(eGon2_key_get_status() == 1)			//ͨADC
//	{
//		return 1;
//	}
//	eGon2_power_vbus_unlimit();
	if(power_int_status[2] & 0x02)			//Դ̰
	{
		return 2;
	}
	if(power_int_status[2] & 0x01)			//Դ
	{
		return 3;
	}
	dcin_exist = 100;
	battery_exist = 100;
	eGon2_power_get_dcin_battery_exist(&dcin_exist, &battery_exist);
	if(!dcin_exist)							//ⲿԴƳ
	{
		return 4;
	}
//	if((power_int_status[1] & 0x04) && (battery_exist==1))			//
//	{
//		return 5;
//	}
	if(power_int_status[0] & 0x08)			//usbţ
	{
		return 8;
	}
	if(power_int_status[0] & 0x04)			//usbţƳ
	{
		return 9;
	}

	//ԭ32K
	standby_clock_divsetto0();
	standby_clock_apb1_to_source(32000);
	standby_clock_to_source(32000);
	standby_clock_24m_op(0);

	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static int eGon2_mod_enter_standby(void)
{
	int i;

	for(i=0;i<EMOD_COUNT_MAX;i++)
	{
		eGon2_driver_standby(i, EGON2_MOD_ENTER_STANDBY, 0);
	}

	return 0;
}
/*
************************************************************************************************************
*
*                                             function
*
*    ƣ
*
*    б
*
*    ֵ  
*
*    ˵    
*
*
************************************************************************************************************
*/
static int eGon2_mod_exit_standby(void)
{
	int i;

	for(i=0;i<EMOD_COUNT_MAX;i++)
	{
		eGon2_driver_standby(i, EGON2_MOD_EXIT_STANDBY, 0);
	}

	return 0;
}




